/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include "a.h"

/* is a t_hash_destroy_proc.
   It is used internally by id_ptr_delete(3). */
VOID_FUNC		id_ptr_destroy_elt(he,id)
t_hash_elt		*he;
t_id			*id;
{
  id->ht->free_proc(he->value,
		    id->ht->comment,
		    "*:ptr");
}

/* deletes an id and performs a free(3) (a free_proc) for each value. 
   It assumes that every value of an association points to a valid
   memory zone. */
VOID_FUNC		id_ptr_delete(id)
t_id			*id;
{
  t_free_proc		free_proc;
  char			*comment;

  free_proc = id->ht->free_proc;
  comment = id->ht->comment;
  hash_delete(id->ht,
	      (t_hash_destroy_proc)id_ptr_destroy_elt,
	      id);
  free_proc(id,
	    comment,
	    "*:id");
}
