/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef A_ERR_H
#define A_ERR_H	1

#include "a.h"

#define ERR_MAGIC_SYS		65535

#define ERR_LOOKUP_ERRNO(Err)	((Err) > ERR_MAGIC_SYS)

#define ERR_A_START		0
#define ERR_A_END		255

#define ERR_A_ERROR_ZERO	(ERR_A_START + 0)
#define ERR_A_ZERO_LEN		(ERR_A_START + 1)
#define ERR_A_TRUNC		(ERR_A_START + 2)
#define ERR_A_BO		(ERR_A_START + 3)
#define ERR_A_SYNTAX		(ERR_A_START + 4)
#define ERR_A_INVAL		(ERR_A_START + 5)
#define ERR_A_BAD_ASCII_VEC	(ERR_A_START + 6)
#define ERR_A_EXIST		(ERR_A_START + 7)
#define ERR_A_BREAK		(ERR_A_START + 8)
#define ERR_A_NOT_FOUND		(ERR_A_START + 9)
#define ERR_A_IDENTICAL		(ERR_A_START + 10)
#define ERR_A_NO_SUCH_KEY	(ERR_A_START + 11)
#define ERR_A_NOENT		(ERR_A_START + 12)
#define ERR_A_NO_SUCH_BASE	(ERR_A_START + 13)
#define ERR_A_UNRECOG_BASE	(ERR_A_START + 14)
#define ERR_A_NEED_MORE		(ERR_A_START + 15)
#define ERR_A_TOO_MANY		(ERR_A_START + 16)
#define ERR_A_BAD_MATCH		(ERR_A_START + 17)
#define ERR_A_BAD_FMT		(ERR_A_START + 18)
#define ERR_A_DIV_BY_ZERO	(ERR_A_START + 19)
#define ERR_A_READ		(ERR_A_START + 20 + ERR_MAGIC_SYS)
#define ERR_A_NO_MEM		(ERR_A_START + 21 + ERR_MAGIC_SYS)
#define ERR_A_BOOLEAN_SYNTAX	(ERR_A_START + 22)
#define ERR_A_PRINTF_END	(ERR_A_START + 23)
#define ERR_A_PRINTF_BAD_FMT	(ERR_A_START + 24)
#define ERR_A_PRINTF_NULL	(ERR_A_START + 25)

extern t_id			*err_id;

/* PROTO a_err.c */
/* a_err.c */
t_status err_init P((void));
char *err_msg P((t_status errcode));
void err_print P((int errcode, char *fmt, ...));
#endif
