/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef A_PRINTF_H
#define A_PRINTF_H	1

#include "a.h"

typedef t_status	(*t_printf_proc) P((VOID_PTR data,
					    char *buf,
					    int len));

/* PROTO a_printf.c */
/* a_printf.c */
t_status my_printf_char P((t_printf_proc proc, void *data, int c));
t_status my_printf_str P((t_printf_proc proc, void *data, char *str));
t_status my_printf_do_str P((t_printf_proc proc, void *data, char *value, int ljust, int len, int zpad));
t_status my_printf_do_num P((t_printf_proc proc, void *data, long value, int base, int dosign, int ljust, int len, int zpad));
t_status my_vprintf P((t_printf_proc proc, void *data, char *fmt, va_list args));
t_status my_printf P((t_printf_proc proc, void *data, char *fmt, ...));
#endif
