/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_H
#define PAT_H	1

#include "paterr.h"
#include "patdef.h"

#ifdef DEBUG_MALLOC
# include "gdm.h"
# define PAT_ALLOC_ALGORITHM	gdm_alloc_algorithm 
# define PAT_ALLOC_PROC		gdm_alloc
# define PAT_REALLOC_PROC	gdm_realloc
# define PAT_FREE_PROC		gdm_free
#else
# define PAT_ALLOC_ALGORITHM	alloc_algorithm_factor2
# define PAT_ALLOC_PROC		alloc_malloc
# define PAT_REALLOC_PROC	realloc_realloc
# define PAT_FREE_PROC		free_free
#endif

#define PAT_VEC_NEW(statusp)	vec_new(VEC_BASE,\
					FALSE,\
					PAT_ALLOC_ALGORITHM,\
					PAT_ALLOC_PROC,\
					PAT_REALLOC_PROC,\
					PAT_FREE_PROC,\
					"pat_vec",\
					(statusp))

#define PAT_DICT_NEW(HashBase,VecBase,StatusPtr) dict_new((HashBase),\
								  (VecBase),\
						 dict_hash_code_public,\
						  PAT_ALLOC_ALGORITHM,\
						  PAT_ALLOC_PROC,\
						  PAT_REALLOC_PROC,\
						  PAT_FREE_PROC,\
								"pat_dict",\
								  (StatusPtr))

#define PAT_ID_NEW(statusp)	id_new(HASH_BASE,\
				       VEC_BASE,\
				       PAT_ALLOC_ALGORITHM,\
				       PAT_ALLOC_PROC,\
				       PAT_REALLOC_PROC,\
				       PAT_FREE_PROC,\
				       "pat_id",\
				       (statusp))

#define PAT_TINY_ID_NEW(statusp)	id_new(HASH_TINY_BASE,\
					       VEC_BASE,\
					       PAT_ALLOC_ALGORITHM,\
					       PAT_ALLOC_PROC,\
					       PAT_REALLOC_PROC,\
					       PAT_FREE_PROC,\
					       "pat_tiny_id",\
					       (statusp))

extern t_boolean		pat_resolve;
extern t_32			pat_base;
extern t_32			pat_verb_level;
extern t_32			pat_zone;
extern t_mask_def		pat_verb_level_mask_defs[];

#ifdef DEBUG
# define VERB_PAT_NBSTUFF	(1L<<0)
# define VERB_PAT_PKT		(1L<<1)
# define VERB_PAT_PKTSAV	(1L<<2)
# define VERB_PAT_PKTIO		(1L<<3)

# define PAT_VERB(level)	((pat_verb_level != 0L)?\
				 (level) & pat_verb_level:FALSE) 
#endif

/* PROTO pat.c */
/* pat.c */
t_status pat_init P((void));
void pat_destroy P((void));
void pat_debug_init P((void));
#endif
