/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_16_H
#define PAT_16_H	1

#include "pat.h"


#include <arpa/inet.h>
#ifndef ntohl
#define ntohl(x)        (x)
#define ntohs(x)        (x)
#define htonl(x)        (x)
#define htons(x)        (x)
#endif

#define UNSAFE_NTOHS	ntohs
#define UNSAFE_HTONS	htons

extern t_pat		ns16_pat;
extern t_pat		nu16_pat;
extern t_pat		u16_pat;
extern t_pat		nu16assoc_pat;
extern t_pat		nu16bitfield_pat;
extern t_pat		nu16bitfieldassoc_pat;

/* PROTO pat_16.c */
/* pat_16.c */
t_u16 safe_ntohs P((t_u16 *p_nu16));
void safe_htons P((int a_u16, t_u16 *p_nu16));
t_status sixteen_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status ns16_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status ns16_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status ns16_pat_insert P((void *data, char *buf, int len, char *value));
t_status nu16_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status nu16_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status nu16_pat_insert P((void *data, char *buf, int len, char *value));
t_status u16_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status u16_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status u16_pat_insert P((void *data, char *buf, int len, char *value));
t_status nu16assoc_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status nu16assoc_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status nu16assoc_pat_insert P((void *data, char *buf, int len, char *value));
t_status nu16assoc_pat_get_choices P((void *data, char *buf, int len, t_vec *vec_str, t_boolean *do_sort_return));
t_status nu16bitfield_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status nu16bitfield_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status nu16bitfield_pat_insert P((void *data, char *buf, int len, char *value));
t_status nu16bitfieldassoc_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status nu16bitfieldassoc_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status nu16bitfieldassoc_pat_insert P((void *data, char *buf, int len, char *value));
t_status nu16bitfieldassoc_pat_get_choices P((void *data, char *buf, int len, t_vec *vec_str, t_boolean *do_sort_return));
#endif
