/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_32_H
#define PAT_32_H	1

#include "pat.h"

#include <arpa/inet.h>
#ifndef ntohl
#define ntohl(x)        (x)
#define ntohs(x)        (x)
#define htonl(x)        (x)
#define htons(x)        (x)
#endif


#define UNSAFE_NTOHL	ntohl
#define UNSAFE_HTONL	htonl

extern t_pat		ns32_pat;
extern t_pat		nu32_pat;
extern t_pat		u32_pat;
extern t_pat		nu32assoc_pat;
extern t_pat		u32assoc_pat;
extern t_pat		u32mask_pat;

/* PROTO pat_32.c */
/* pat_32.c */
t_u32 safe_ntohl P((t_u32 *p_nu32));
void safe_htonl P((t_u32 a_u32, t_u32 *p_nu32));
t_status thirtytwo_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status ns32_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status ns32_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status ns32_pat_insert P((void *data, char *buf, int len, char *value));
t_status nu32_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status nu32_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status nu32_pat_insert P((void *data, char *buf, int len, char *value));
t_status u32_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status u32_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status u32_pat_insert P((void *data, char *buf, int len, char *value));
t_status nu32assoc_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status nu32assoc_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status nu32assoc_pat_insert P((void *data, char *buf, int len, char *value));
t_status nu32assoc_pat_get_choices P((void *data, char *buf, int len, t_vec *vec_str, t_boolean *do_sort_return));
t_status u32assoc_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status u32assoc_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status u32assoc_pat_insert P((void *data, char *buf, int len, char *value));
t_status u32assoc_pat_get_choices P((void *data, char *buf, int len, t_vec *vec_str, t_boolean *do_sort_return));
t_status u32mask_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status u32mask_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status u32mask_pat_insert P((void *data, char *buf, int len, char *value));
#endif
