/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_DATA_H
#define PAT_DATA_H	1

#include "pat.h"

extern t_u32		pat_data_bytes_per_line;
extern t_pat		data_pat;
extern t_pat		dataebcdic_pat;
extern t_pat		datalen_pat;

/* PROTO pat_data.c */
/* pat_data.c */
t_status ebcdic_buf_to_cooked_str_i P((int off, unsigned char *b, int l, int br, char *br_str, char *spc_str, char *big_spc_str, char *nonprint_str, t_vec *ascii_vec, char *str, int max_len));
t_status ebcdic_buf_to_cooked_str P((char *buf, int len, int br, char *br_str, char *spc_str, char *big_spc_str, char *nonprint_str, t_vec *ascii_vec, char *str, int max_len));
void pat_data_destroy P((void));
t_status ascii_vec_default P((t_vec *vec));
t_status ebcdic_to_ascii_vec_default P((t_vec *vec));
t_status pat_data_init P((void));
t_status data_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status data_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status data_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status data_pat_get_fields P((void *data, t_vec *vec_str));
t_status dataebcdic_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status dataebcdic_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status dataebcdic_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status dataebcdic_pat_get_fields P((void *data, t_vec *vec_str));
t_status datalen_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status datalen_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
#endif
