/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_DNS_H
#define PAT_DNS_H	1

#include "pat.h"

typedef struct		s_dns
{
  t_u16			id;
  t_u16			flags;
  t_u16			nquestions;
  t_u16			nanswers;
  t_u16			nauths;
  t_u16			nadds;
} t_dns;

#define DNS_HLEN	(sizeof (t_dns))

#define DNS_PORT	53

#define PAT_DNS_CHECK(dnspar,bufpar,lenpar) \
	if ((lenpar) < DNS_HLEN)\
		return (-ERR_PAT_TRUNC);\
	(dnspar) = (t_dns *)(bufpar);

extern int		dns_nquestions_chan;

extern t_pat		dnsrttl_pat;
extern t_pat		dnsrdata_pat;
extern t_pat		dnsqtype_pat;
extern t_pat		dnsqname_pat;
extern t_pat		dns_pat;

/* PROTO pat_dns.c */
/* pat_dns.c */
t_status dnsrttl_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status dnsrttl_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status dnsrttl_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status dnsrttl_pat_get_fields P((void *data, t_vec *vec_str));
t_status dnsrttl_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status dnsrttl_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status dnsrttl_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status dnsrttl_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
t_status dnsrdata_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status dnsrdata_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status dnsrdata_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status dnsrdata_pat_get_fields P((void *data, t_vec *vec_str));
t_status dnsrdata_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status dnsrdata_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status dnsrdata_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
t_status dnsqtype_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status dnsqtype_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status dnsqtype_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status dnsqtype_pat_get_fields P((void *data, t_vec *vec_str));
t_status dnsqtype_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status dnsqtype_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status dnsqtype_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status dnsqtype_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
t_status dnsqname_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status dnsqname_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status dnsqname_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status dnsqname_pat_get_fields P((void *data, t_vec *vec_str));
t_status dnsqname_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status dnsqname_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status dnsqname_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status dnsqname_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
t_status dnsqname_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status dnsqname_pat_insert P((void *data, char *buf, int len, char *value));
t_status dns_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status dns_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status dns_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status dns_pat_get_fields P((void *data, t_vec *vec_str));
t_status dns_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status dns_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status dns_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status dns_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
#endif
