/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_ETHADDR_H
#define PAT_ETHADDR_H	1

#include "pat.h"

typedef struct		s_ether_addr
{
  t_u8			o[6];
} t_ether_addr;

extern t_boolean	etheraddr_dec_way;
extern t_pat		etheraddr_pat;

/* PROTO pat_ethaddr.c */
/* pat_ethaddr.c */
t_status etheraddr_from_str P((t_ether_addr *ea, char *str));
t_status etheraddr_to_str P((t_ether_addr *ea, char *str, int max_len));
char *typ_etheraddr_ntoa P((t_ether_addr *ea));
t_status etheraddr_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status etheraddr_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status etheraddr_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status etheraddr_pat_get_fields P((void *data, t_vec *vec_str));
t_status etheraddr_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status etheraddr_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status etheraddr_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status etheraddr_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
t_status etheraddr_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status etheraddr_pat_insert P((void *data, char *buf, int len, char *value));
#endif
