/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_IEEE802_H
#define PAT_IEEE802_H	1

#include "pat.h"
#include "pat_ethaddr.h"

typedef struct		s_llc
{
  t_u8			dsap;
  t_u8			ssap;
  t_u8			cntl;
} t_llc;

#define LLC_HLEN	(sizeof (t_llc))

#define PAT_LLC_CHECK(llcpar,bufpar,lenpar) \
	if ((lenpar) < LLC_HLEN)\
		return (-ERR_PAT_TRUNC);\
	(llcpar) = (t_llc *)(bufpar);

typedef struct		s_snap
{
  t_u8			orgcode[3];
  t_u16			type;
} t_snap;

#define SNAP_HLEN	(sizeof (t_snap))

#define PAT_SNAP_CHECK(snappar,bufpar,lenpar) \
	if ((lenpar) < SNAP_HLEN)\
		return (-ERR_PAT_TRUNC);\
	(snappar) = (t_snap *)(bufpar);

#define LLCSAP_SNAP	0xaa

#define LLC_UI		0x03

extern t_pat		llc_pat;
extern t_pat		snap_pat;

/* PROTO pat_ieee802.c */
/* pat_ieee802.c */
t_status llc_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status llc_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status llc_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status llc_pat_get_fields P((void *data, t_vec *vec_str));
t_status llc_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status llc_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status llc_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status llc_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
int snap_get_type P((t_snap *snap));
t_status snap_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status snap_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status snap_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status snap_pat_get_fields P((void *data, t_vec *vec_str));
t_status snap_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status snap_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status snap_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status snap_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
#endif
