/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_INADDR_H
#define PAT_INADDR_H	1

#include "pat.h"

/* THIS IS REDEFINED TO AVOID SOME INCLUDE PROBLEMS */
typedef struct			s_in_addr
{
  t_u32				s_addr;
} t_in_addr;

extern t_pat			inaddr_pat;
extern t_pat			inaddr_resolved_pat;

/* PROTO pat_inaddr.c */
/* pat_inaddr.c */
int inaddr_cmp P((struct in_addr *addr1, struct in_addr *addr2));
t_status inaddr_from_str P((char *str, struct in_addr *mba_inaddr, t_boolean resolve));
t_status inaddr_to_str P((struct in_addr *mba_inaddr, char *str, int max_len, t_boolean resolve));
t_status inaddr_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status inaddr_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status inaddr_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status inaddr_pat_get_fields P((void *data, t_vec *vec_str));
t_status inaddr_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status inaddr_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status inaddr_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status inaddr_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
t_status inaddr_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status inaddr_pat_insert P((void *data, char *buf, int len, char *value));
t_status inaddr_resolved_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status inaddr_resolved_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status inaddr_resolved_pat_insert P((void *data, char *buf, int len, char *value));
#endif
