/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_MAC_H
#define PAT_MAC_H	1

#include "pat_ether.h"

typedef struct		s_mac
{
  int			byte0;
  int			byte1;
  int			byte2;
  int			byte3;
  int			byte4;
  int			byte5;
  char			*name;
} t_mac;

#define MAC_ANY		256

extern t_pat		mac_pat;

/* PROTO pat_mac.c */
/* pat_mac.c */
t_status mac_to_str P((t_ether_addr *ea, char *str, int max_len));
t_status mac_from_str P((t_ether_addr *ea, char *str));
t_status mac_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status mac_pat_extract P((void *data, char *buf, int len, char *str, int max_len));
t_status mac_pat_insert P((void *data, char *buf, int len, char *value));
t_status mac_pat_get_choices P((void *data, char *buf, int len, t_vec *vec_str, t_boolean *do_sort_return));
#endif
