/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_RIP_H
#define PAT_RIP_H	1

#include "pat.h"

typedef struct		s_ripinfo
{
  t_u16			family;
  t_u16			tag;
  t_32			dst;
  t_32			mask;
  t_32			router;
  t_32			metric;
} t_ripinfo;

#define RIPINFO_HLEN	(sizeof (t_ripinfo))

#define PAT_RIPINFO_CHECK(ripinfopar,bufpar,lenpar) \
	if ((lenpar) < RIPINFO_HLEN)\
		return (-ERR_PAT_TRUNC);\
	(ripinfopar) = (t_ripinfo *)(bufpar);

extern t_assoc		family_assocs[];

typedef struct		s_rip
{
  t_u8			cmd;
  t_u8			v;
  t_u16			mbz;
} t_rip;

#define RIP_HLEN	(sizeof (t_rip))

#define RIP_PORT	520

#define PAT_RIP_CHECK(rippar,bufpar,lenpar) \
	if ((lenpar) < RIP_HLEN)\
		return (-ERR_PAT_TRUNC);\
	(rippar) = (t_rip *)(bufpar);

extern t_assoc		ripcmd_assocs[];

extern t_pat		ripinfo_pat;
extern t_pat		rip_pat;

/* PROTO pat_rip.c */
/* pat_rip.c */
t_status ripinfo_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status ripinfo_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status ripinfo_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status ripinfo_pat_get_fields P((void *data, t_vec *vec_str));
t_status ripinfo_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status ripinfo_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status ripinfo_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status ripinfo_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
t_status rip_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status rip_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status rip_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status rip_pat_get_fields P((void *data, t_vec *vec_str));
t_status rip_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status rip_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status rip_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status rip_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
#endif
