/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef PAT_RPC_H
#define PAT_RPC_H	1

#include "pat.h"

typedef struct			s_rpccall
{
  t_u32				rpcversion;
  t_u32				program;
  t_u32				version;
  t_u32				procedure;
} t_rpccall;

#define RPCCALL_HLEN		(sizeof (t_rpccall))

#define PAT_RPCCALL_CHECK(rpccallpar,bufpar,lenpar) \
	if ((lenpar) < RPCCALL_HLEN)\
		return (-ERR_PAT_TRUNC);\
	(rpccallpar) = (t_rpccall *)(bufpar);

#define RPCCALL_PORT		111

#define RPCCALLDIRECTION_CALL	0
#define RPCCALLDIRECTION_REPLY	1

typedef struct			s_rpc
{
  t_u32				xid;
  t_u32				direction;
} t_rpc;

#define RPC_HLEN		(sizeof (t_rpc))

#define PAT_RPC_CHECK(rpcpar,bufpar,lenpar) \
	if ((lenpar) < RPC_HLEN)\
		return (-ERR_PAT_TRUNC);\
	(rpcpar) = (t_rpc *)(bufpar);

#define RPC_PORT		111

#define RPCDIRECTION_CALL	0
#define RPCDIRECTION_REPLY	1

extern t_pat			rpccall_pat;
extern t_pat			rpc_pat;

/* PROTO pat_rpc.c */
/* pat_rpc.c */
t_status rpccall_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status rpccall_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status rpccall_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status rpccall_pat_get_fields P((void *data, t_vec *vec_str));
t_status rpccall_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status rpccall_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status rpccall_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status rpccall_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
t_status rpc_pat_name P((void *data, t_id *optional_id, char *str, int max_len));
t_status rpc_pat_get_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *str, int max_len));
t_status rpc_pat_set_field P((void *data, t_id *optional_id, char *buf, int len, char *field, char *value));
t_status rpc_pat_get_fields P((void *data, t_vec *vec_str));
t_status rpc_pat_get_field_pat P((void *data, t_id *optional_id, char *buf, int len, char *field, t_pat **pat_return, void **data_return));
t_status rpc_pat_get_tmpl P((void *data, t_id *id, char *buf, int len, char *str, int max_len));
t_status rpc_pat_off P((void *data, char *buf, int len, t_off *off_return));
t_status rpc_pat_sub P((void *data, t_id *optional_id, char *buf, int len, t_pat **pat_return));
#endif
