/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include "pat.h"
#include "pat_16.h"

t_u16				safe_ntohs(p_nu16)
t_u16				*p_nu16;/* Pointer to network unsigned short */
{
  t_u16				a_u16;
  
  FBCOPY(p_nu16,&a_u16,sizeof (t_u16));
  return (UNSAFE_NTOHS(a_u16));
}

VOID_FUNC			safe_htons(a_u16,p_nu16)
t_u16				a_u16;	/* Aligned host unsigned short */
t_u16				*p_nu16;/* Pointer to network unsigned short */
{
  a_u16 = UNSAFE_HTONS(a_u16);  
  FBCOPY(&a_u16,p_nu16,sizeof (t_u16));
}

PAT_OFF_GENERIC(sixteen_pat_off,
		2)

int ns16_chan;
PAT_NAME_GENERIC(ns16_pat_name,
		 (VOID_PTR)&ns16_chan,
		 "ns16")

PAT_EXTRACT_DECL(ns16_pat_extract)
{
  t_s16				s16;
	
  if (len < sizeof (s16))
    return (-ERR_PAT_TRUNC);
  FBCOPY(buf,&s16,sizeof (s16));
  s16 = UNSAFE_NTOHS(s16);
  return (long_to_str((signed long)s16,
		      pat_base,
		      str,
		      max_len));
}

PAT_INSERT_DECL(ns16_pat_insert)
{
  t_s16				s16;
  t_status			status;	
  int				basenum;
  signed long			num;
  
  if (len < sizeof (s16))
    return (-ERR_PAT_TRUNC);
  if ((status = long_from_str(value,
			      &basenum,
			      &num)) < 0)
    return (status);
  s16 = (t_s16)num;
  s16 = UNSAFE_HTONS(s16);
  FBCOPY(&s16,buf,sizeof (s16));
  return (0);
}

t_pat				ns16_pat = 
{
  ns16_pat_name,		/* t_pat_name_proc		*/
  sixteen_pat_off,		/* t_pat_off_proc		*/
  NULL,				/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  NULL,				/* t_pat_get_field_proc	*/
  NULL,				/* t_pat_set_field_proc	*/
  NULL,				/* t_pat_get_fields_proc	*/
  NULL,				/* t_pat_get_tmpl_proc	*/
  NULL,				/* t_pat_get_tmpl2_proc	*/
  NULL,				/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc	*/
  NULL,				/* t_pat_get_field_pat_proc	*/
  ns16_pat_extract,		/* t_pat_extract_proc		*/
  ns16_pat_insert,		/* t_pat_insert_proc		*/
  NULL,				/* t_pat_get_choices_proc	*/
};

int nu16_chan;
PAT_NAME_GENERIC(nu16_pat_name,
		 (VOID_PTR)&nu16_chan,
		 "nu16")

PAT_EXTRACT_DECL(nu16_pat_extract)
{
  t_u16				u16;

  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  FBCOPY(buf,&u16,sizeof (u16));
  u16 = UNSAFE_NTOHS(u16);
  return (ulong_to_str((unsigned long)u16,
		       pat_base,
		       str,
		       max_len));
}

PAT_INSERT_DECL(nu16_pat_insert)
{
  t_u16				u16;
  t_status			status;	
  int				basenum;
  unsigned long			num;
  
  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  if ((status = ulong_from_str(value,
			       &basenum,
			       &num)) < 0)
    return (status);
  u16 = (t_u16)num;
  u16 = UNSAFE_HTONS(u16);
  FBCOPY(&u16,buf,sizeof (u16));
  return (0);
}

t_pat				nu16_pat = 
{
  nu16_pat_name,		/* t_pat_name_proc		*/
  sixteen_pat_off,		/* t_pat_off_proc		*/
  NULL,				/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  NULL,				/* t_pat_get_field_proc	*/
  NULL,				/* t_pat_set_field_proc	*/
  NULL,				/* t_pat_get_fields_proc	*/
  NULL,				/* t_pat_get_tmpl_proc	*/
  NULL,				/* t_pat_get_tmpl2_proc	*/
  NULL,				/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc	*/
  NULL,				/* t_pat_get_field_pat_proc	*/
  nu16_pat_extract,		/* t_pat_extract_proc		*/
  nu16_pat_insert,		/* t_pat_insert_proc		*/
  NULL,				/* t_pat_get_choices_proc	*/
};

int u16_chan;
PAT_NAME_GENERIC(u16_pat_name,
		 (VOID_PTR)&u16_chan,
		 "u16")

PAT_EXTRACT_DECL(u16_pat_extract)
{
  t_u16				u16;

  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  FBCOPY(buf,&u16,sizeof (u16));
  return (ulong_to_str((unsigned long)u16,
		       pat_base,
		       str,
		       max_len));
}

PAT_INSERT_DECL(u16_pat_insert)
{
  t_u16				u16;
  t_status			status;	
  int				basenum;
  unsigned long			num;

  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  if ((status = ulong_from_str(value,
			       &basenum,
			       &num)) < 0)
    return (status);
  u16 = (t_u16)num;
  FBCOPY(&u16,buf,sizeof (u16));
  return (0);
}

t_pat				u16_pat = 
{
  u16_pat_name,			/* t_pat_name_proc		*/
  sixteen_pat_off,		/* t_pat_off_proc		*/
  NULL,				/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  NULL,				/* t_pat_get_field_proc	*/
  NULL,				/* t_pat_set_field_proc	*/
  NULL,				/* t_pat_get_fields_proc	*/
  NULL,				/* t_pat_get_tmpl_proc	*/
  NULL,				/* t_pat_get_tmpl2_proc	*/
  NULL,				/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc	*/
  NULL,				/* t_pat_get_field_pat_proc	*/
  u16_pat_extract,		/* t_pat_extract_proc		*/
  u16_pat_insert,		/* t_pat_insert_proc		*/
  NULL,				/* t_pat_get_choices_proc	*/
};

int nu16assoc_chan;
PAT_NAME_GENERIC(nu16assoc_pat_name,
		 (VOID_PTR)&nu16assoc_chan,
		 "nu16assoc")

PAT_EXTRACT_DECL(nu16assoc_pat_extract)
{
  t_u16				u16;
  t_assoc			*assocs;
  t_assoc			*assoc;

  if ((assocs = (t_assoc *)(data)) == NULL)
    return (-ERR_PAT_NULL_DATA);
  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  FBCOPY(buf,&u16,sizeof (u16));
  u16 = UNSAFE_NTOHS(u16);
  if (assoc = assoc_str_int_from_right(assocs,(int)u16))
    return (str_cat_str(str,
			max_len,
			assoc->left));
  else
    return (ulong_to_str((unsigned long)u16,
			 pat_base,
			 str,
			 max_len));
}

PAT_INSERT_DECL(nu16assoc_pat_insert)
{
  t_u16				u16;
  t_status			status;	
  t_assoc			*assocs;
  t_assoc			*assoc;
  
  if ((assocs = (t_assoc *)(data)) == NULL)
    return (-ERR_PAT_NULL_DATA);
  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  if (assoc = assoc_str_ptr_from_left(assocs,value))
    u16 = (t_u16)(t_u32)(assoc->right);
  else
    {
      int			basenum;
      unsigned long		num;
      
      if ((status = ulong_from_str(value,
				   &basenum,
				   &num)) < 0)
	return (status);
      u16 = (t_u16)num;
    }
  u16 = UNSAFE_HTONS(u16);
  FBCOPY(&u16,buf,sizeof (u16));
  return (0);
}

PAT_GET_CHOICES_DECL(nu16assoc_pat_get_choices)
{
  t_assoc		*assocs;
  t_assoc		*assoc;
  t_status		status;

  if ((assocs = (t_assoc *)(data)) == NULL)
    return (-ERR_PAT_NULL_DATA);
  assoc = assocs;
  while (assoc->left)
    {
      if ((status = vec_str_add(vec_str,assoc->left)) < 0)
	return (status);
      assoc++;
    }
  return (0);
}

t_pat				nu16assoc_pat = 
{
  nu16assoc_pat_name,		/* t_pat_name_proc		*/
  sixteen_pat_off,		/* t_pat_off_proc		*/
  NULL,				/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  NULL,				/* t_pat_get_field_proc	*/
  NULL,				/* t_pat_set_field_proc	*/
  NULL,				/* t_pat_get_fields_proc	*/
  NULL,				/* t_pat_get_tmpl_proc	*/
  NULL,				/* t_pat_get_tmpl2_proc	*/
  NULL,				/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc	*/
  NULL,				/* t_pat_get_field_pat_proc	*/
  nu16assoc_pat_extract,	/* t_pat_extract_proc		*/
  nu16assoc_pat_insert,		/* t_pat_insert_proc		*/
  nu16assoc_pat_get_choices,	/* t_pat_get_choices_proc	*/
};

int nu16bitfield_chan;
PAT_NAME_GENERIC(nu16bitfield_pat_name,
		 (VOID_PTR)&nu16bitfield_chan,
		 "nu16bitfield")

PAT_EXTRACT_DECL(nu16bitfield_pat_extract)
{
  t_u16			u16;
  t_bit_field		*bf;

  if ((bf = (t_bit_field *)(data)) == NULL)
    return (-ERR_PAT_NULL_DATA);
  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  FBCOPY(buf,&u16,sizeof (u16));
  u16 = UNSAFE_NTOHS(u16);
  u16 = *bit_field_u16_get(&u16,bf->from,bf->to);
  return (ulong_to_str((unsigned long)u16,
		       pat_base,
		       str,
		       max_len));
}

PAT_INSERT_DECL(nu16bitfield_pat_insert)
{
  t_u16				u16;
  t_u16				u16value;
  t_bit_field			*bf;
  int				basenum;
  unsigned long			num;
  t_status			status;

  if ((bf = (t_bit_field *)(data)) == NULL)
    return (-ERR_PAT_NULL_DATA);
  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  FBCOPY(buf,&u16,sizeof (u16));
  u16 = UNSAFE_NTOHS(u16); 
  if ((status = ulong_from_str(value,
			       &basenum,
			       &num)) < 0)
    return (status);
  u16value = (t_u16)num;
  bit_field_u16_set(&u16,bf->from,
		    bf->to,
		    u16value);
  u16 = UNSAFE_HTONS(u16); 
  FBCOPY(&u16,buf,sizeof (u16));
  return (0);
}

t_pat				nu16bitfield_pat = 
{
  nu16bitfield_pat_name,	/* t_pat_name_proc		*/
  sixteen_pat_off,		/* t_pat_off_proc		*/
  NULL,				/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  NULL,				/* t_pat_get_field_proc	*/
  NULL,				/* t_pat_set_field_proc	*/
  NULL,				/* t_pat_get_fields_proc	*/
  NULL,				/* t_pat_get_tmpl_proc	*/
  NULL,				/* t_pat_get_tmpl2_proc	*/
  NULL,				/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc	*/
  NULL,				/* t_pat_get_field_pat_proc	*/
  nu16bitfield_pat_extract,	/* t_pat_extract_proc		*/
  nu16bitfield_pat_insert,	/* t_pat_insert_proc		*/
  NULL,				/* t_pat_get_choices_proc	*/
};

int nu16bitfieldassoc_chan;
PAT_NAME_GENERIC(nu16bitfieldassoc_pat_name,
		 (VOID_PTR)&nu16bitfieldassoc_chan,
		 "nu16bitfieldassoc")

PAT_EXTRACT_DECL(nu16bitfieldassoc_pat_extract)
{
  t_u16				u16;
  t_bit_field_assocs_data	*bfad;
  t_assoc			*assoc;

  if ((bfad = (t_bit_field_assocs_data *)(data)) == NULL)
    return (-ERR_PAT_NULL_DATA);
  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  FBCOPY(buf,&u16,sizeof (u16));
  u16 = UNSAFE_NTOHS(u16);
  u16 = *bit_field_u16_get(&u16,
			   bfad->bit_field->from,
			   bfad->bit_field->to);
  if (assoc = assoc_str_int_from_right(bfad->assocs,(int)u16))
    return (str_cat_str(str,
			max_len,
			assoc->left));
  else
    return (ulong_to_str((unsigned long)u16,
			 pat_base,
			 str,
			 max_len));
}

PAT_INSERT_DECL(nu16bitfieldassoc_pat_insert)
{
  t_u16				u16;
  t_u16				u16value;
  t_bit_field_assocs_data	*bfad;
  t_assoc			*assoc;
  t_status		status;
  
  if ((bfad = (t_bit_field_assocs_data *)(data)) == NULL)
    return (-ERR_PAT_NULL_DATA);
  if (len < sizeof (u16))
    return (-ERR_PAT_TRUNC);
  FBCOPY(buf,&u16,sizeof (u16));
  u16 = UNSAFE_NTOHS(u16); 
  if (assoc = assoc_str_ptr_from_left(bfad->assocs,value))
    u16value = (t_u16)(t_u32)(assoc->right);
  else
    {
      int		basenum;
      unsigned long	num;
      
      if ((status = ulong_from_str(value,
				   &basenum,
				   &num)) < 0)
	return (status);
      u16value = (t_u16)num;
    }
  bit_field_u16_set(&u16,
		    bfad->bit_field->from,
		    bfad->bit_field->to,
		    u16value);
  u16 = UNSAFE_HTONS(u16); 
  FBCOPY(&u16,buf,sizeof (u16));
  return (0);
}

PAT_GET_CHOICES_DECL(nu16bitfieldassoc_pat_get_choices)
{
  t_bit_field_assocs_data	*bfad;
  t_assoc			*assoc;
  t_status			status;

  if ((bfad = (t_bit_field_assocs_data *)(data)) == NULL)
    return (-ERR_PAT_NULL_DATA);
  assoc = bfad->assocs;
  while (assoc->left)
    {
      if ((status = vec_str_add(vec_str,assoc->left)) < 0)
	return (status);
      assoc++;
    }
  return (0);
}

t_pat				nu16bitfieldassoc_pat = 
{
  nu16bitfieldassoc_pat_name,	/* t_pat_name_proc		*/
  sixteen_pat_off,		/* t_pat_off_proc		*/
  NULL,				/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  NULL,				/* t_pat_get_field_proc	*/
  NULL,				/* t_pat_set_field_proc	*/
  NULL,				/* t_pat_get_fields_proc	*/
  NULL,				/* t_pat_get_tmpl_proc	*/
  NULL,				/* t_pat_get_tmpl2_proc	*/
  NULL,				/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc	*/
  NULL,				/* t_pat_get_field_pat_proc	*/
  nu16bitfieldassoc_pat_extract,/* t_pat_extract_proc		*/
  nu16bitfieldassoc_pat_insert,	/* t_pat_insert_proc		*/
  nu16bitfieldassoc_pat_get_choices,/* t_pat_get_choices_proc	*/
};
