/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "pat_bootp.h"
#include "pat_ip.h"
#include "pat_ether.h"
#include "pat_data.h"
#include "pat_32.h"
#include "pat_16.h"
#include "pat_8.h"
#include "pat_inaddr.h"
#include "pat_buf.h"
#include "pat_sz.h"
#include "pat_time.h"

t_boolean			pat_bootp_rfc2132 = TRUE;

char				*rfc2132optdata_itmpl = "\n\
<table _name=rfc2132optdata[%i%] width=100%%%% bgcolor=\"%%rfc2132optColor%%\">\n\
<tr>\n\
<td width=100%%%%>\n\
<code>\n\
%%rfc2132optdata[%i%].cookedhtmlbuf%%\n\
</code>\n\
</tr>\n\
</table>\n\
<br>\n\
";

int	rfc2132optdata_chan;

PAT_NAME_GENERIC(rfc2132optdata_pat_name,
		 (VOID_PTR)&rfc2132optdata_chan,
		 "rfc2132optdata")

PAT_GET_TMPL_GENERIC(rfc2132optdata_pat_get_tmpl,
		     (VOID_PTR)&rfc2132optdata_chan,
		     rfc2132optdata_itmpl)

t_pat				rfc2132optdata_pat = 
{
  rfc2132optdata_pat_name,	/* t_pat_name_proc		*/
  NULL,				/* t_pat_off_proc		*/
  NULL,				/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  data_pat_get_field,		/* t_pat_get_field_proc		*/
  NULL,				/* t_pat_set_field_proc		*/
  data_pat_get_fields,		/* t_pat_get_fields_proc	*/
  rfc2132optdata_pat_get_tmpl,	/* t_pat_get_tmpl_proc		*/
  NULL,				/* t_pat_get_tmpl2_proc		*/
  NULL,				/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc		*/
  NULL,				/* t_pat_get_field_pat_proc	*/
  NULL,				/* t_pat_extract_proc		*/
  NULL,				/* t_pat_insert_proc		*/
  NULL,				/* t_pat_get_choices_proc	*/
};

t_assoc				rfc2132opt_assocs[] =
{
  {"pad",			(VOID_PTR)0},
  {"end",			(VOID_PTR)255},
  {"subnet_mask",		(VOID_PTR)1},
  {"time_offset",		(VOID_PTR)2},
  {"router",			(VOID_PTR)3},
  {"time_server",		(VOID_PTR)4},
  {"name_server",		(VOID_PTR)5},
  {"domain_name_server",	(VOID_PTR)6},
  {"log_server",		(VOID_PTR)7},
  {"cookie_server",		(VOID_PTR)8},
  {"lpr_server",		(VOID_PTR)9},
  {"impress_server",		(VOID_PTR)10},
  {"resource_location",		(VOID_PTR)11},
  {"host_name",			(VOID_PTR)12},
  {"boot_file_size",		(VOID_PTR)13},
  {"merit_dump",		(VOID_PTR)14},
  {"domain_name",		(VOID_PTR)15},
  {"swap_server",		(VOID_PTR)16},
  {"root_path",			(VOID_PTR)17},
  {"extensions_path",		(VOID_PTR)18},
  {"ip_forwarding",		(VOID_PTR)19},
  {"non_local_source_routing",	(VOID_PTR)20},
  {"policy_filter",		(VOID_PTR)21},
  {"max_dgram_reass_size",	(VOID_PTR)22},
  {"default_ip_ttl",		(VOID_PTR)23},
  {"path_mtu_aging_timeout",	(VOID_PTR)24},
  {"path_mtu_plateau_table",	(VOID_PTR)25},
  {"interface_mtu",		(VOID_PTR)26},
  {"all_subnets_are_local",	(VOID_PTR)27},
  {"broadcast_address",		(VOID_PTR)28},
  {"perform_mask_discovery",	(VOID_PTR)29},
  {"mask_supplier",		(VOID_PTR)30},
  {"perform_router_discovery",	(VOID_PTR)31},
  {"router_solicitation_address",(VOID_PTR)32},
  {"static_route",		(VOID_PTR)33},
  {"trailer_encapsulation",	(VOID_PTR)34},
  {"arp_cache_timeout",		(VOID_PTR)35},
  {"ethernet_encaps",		(VOID_PTR)36},
  {"tcp_default_ttl",		(VOID_PTR)37},
  {"tcp_keepalive_interval",	(VOID_PTR)38},
  {"tcp_keepalive_garbage",	(VOID_PTR)39},
  {"nis_domain",		(VOID_PTR)40},
  {"nis_servers",		(VOID_PTR)41},
  {"ntp_servers",		(VOID_PTR)42},
  {"vendor_specific",		(VOID_PTR)43},
  {"netbios_name_servers",	(VOID_PTR)44},
  {"netbios_dgram_dist_servers",(VOID_PTR)45},
  {"netbios_node_type",		(VOID_PTR)46},
  {"netbios_scope",		(VOID_PTR)47},
  {"x_font_servers",		(VOID_PTR)48},
  {"xdm_servers",		(VOID_PTR)49},
  {"requested_ip_address",	(VOID_PTR)50},
  {"ip_address_lease_time",	(VOID_PTR)51},
  {"overload",			(VOID_PTR)52},
  {"dhcp_message_type",		(VOID_PTR)53},
  {"server_identifier",		(VOID_PTR)54},
  {"parameter_request_list",	(VOID_PTR)55},
  {"message",			(VOID_PTR)56},
  {"max_dhcp_message_size",	(VOID_PTR)57},
  {"renewal_time_value",	(VOID_PTR)58},
  {"rebinding_time_value",	(VOID_PTR)59},
  {"vendor_class_identifier",	(VOID_PTR)60},
  {"client_identifier",		(VOID_PTR)61},
  {"nis+_domain",		(VOID_PTR)64},
  {"nis+_servers",		(VOID_PTR)65},
  {"tftp_server_name",		(VOID_PTR)66},
  {"bootfile_name",		(VOID_PTR)67},
  {"mobile_ip_home_agent",	(VOID_PTR)68},
  {"smtp_servers",		(VOID_PTR)69},
  {"pop3_servers",		(VOID_PTR)70},
  {"nntp_servers",		(VOID_PTR)71},
  {"www_servers",		(VOID_PTR)72},
  {"finger_servers",		(VOID_PTR)73},
  {"irc_servers",		(VOID_PTR)74},
  {"streettalk_servers",	(VOID_PTR)75},
  {"stda_servers",		(VOID_PTR)76},
  NULL_ASSOC
};

t_assoc				rfc2132opt_sub_assocs[] = 
{
  {(VOID_PTR)1,			(VOID_PTR)&inaddr_pat},
  {(VOID_PTR)2,			(VOID_PTR)&time_pat},
};

t_field				rfc2132opt_simple_fields[] = 
{
  {"tag",	0,	&u8_pat,		NULL},
  {"Tag",	0,	&u8assoc_pat,	(VOID_PTR)rfc2132opt_assocs},
  NULL_FIELD
};

t_field				rfc2132opt_double_fields[] = 
{
  {"tag",	0,	&u8_pat,		NULL},
  {"Tag",	0,	&u8assoc_pat,	(VOID_PTR)rfc2132opt_assocs},
  {"len",	1,	&u8_pat,		NULL},
  NULL_FIELD
};

t_field			*rfc2132opt_get_fields(buf,len,status)
char			*buf;
int			len;
t_status		*status;
{
  if (len < 1)
    {
      *status = -ERR_PAT_TRUNC;
      return (NULL);
    }
  switch ((t_u8)(buf[0]))
    {
    case RFC2132OPT_PAD:
    case RFC2132OPT_END:
      return (rfc2132opt_simple_fields);
    default:
      return (rfc2132opt_double_fields);
    }
}

char				*rfc2132opt_simple_itmpl = "\n\
<table _name=rfc2132opt[%i%] bgcolor=\"%%rfc2132optColor%%\" width=100%%%%>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<small>\n\
<a href=\"set(rfc2132opt[%i%].Tag)\">%%rfc2132opt[%i%].Tag%%</a>\n\
(<a href=\"set(rfc2132opt[%i%].tag)\">%%rfc2132opt[%i%].tag%%</a>)\n\
</small>\n\
</td>\n\
</tr>\n\
</table>\n\
<br>\n\
";

char				*rfc2132opt_double_itmpl = "\n\
<table _name=rfc2132opt[%i%] bgcolor=\"%%rfc2132optColor%%\" width=100%%%%>\n\
<tr>\n\
<td align=center width=50%%%%>\n\
<small>\n\
<a href=\"set(rfc2132opt[%i%].Tag)\">%%rfc2132opt[%i%].Tag%%</a>\n\
(<a href=\"set(rfc2132opt[%i%].tag)\">%%rfc2132opt[%i%].tag%%</a>)\n\
</small>\n\
</td>\n\
<td align=center width=50%%%%>\n\
<small>\n\
<a href=\"set(rfc2132opt[%i%].len)\">%%rfc2132opt[%i%].len%%</a>\n\
</small>\n\
</td>\n\
</tr>\n\
</table>\n\
<br>\n\
";

char			*rfc2132opt_get_itmpl(buf,len,status)
char			*buf;
int			len;
t_status		*status;
{
  if (len < 1)
    {
      *status = -ERR_PAT_TRUNC;
      return (NULL);
    }
  switch ((t_u8)(buf[0]))
    {
    case RFC2132OPT_PAD:
    case RFC2132OPT_END:
      return (rfc2132opt_simple_itmpl);
    default:
      return (rfc2132opt_double_itmpl);
    }
}

int		rfc2132opt_chan;

PAT_NAME_GENERIC(rfc2132opt_pat_name,
		 (VOID_PTR)&rfc2132opt_chan,
		 "rfc2132opt")

PAT_OFF_DECL(rfc2132opt_pat_off)
{
  if (len < 1)
    return (-ERR_PAT_TRUNC);
  switch ((t_u8)(buf[0]))
    {
    case RFC2132OPT_PAD:
    case RFC2132OPT_END:
      (*off_return) = 1;
      return (0);
    }
  if (len < 2)
    return (-ERR_PAT_TRUNC);
  (*off_return) = (t_off)(t_u8)(buf[1]) + 2;
  return (0);
}

PAT_SUB_DECL(rfc2132opt_pat_sub)
{
  if (len < 1)
    return (-ERR_PAT_TRUNC);
  switch ((t_u8)(buf[0]))
    {
    case RFC2132OPT_END:
      (*pat_return) = &rfc2132optdata_pat;
      return (0);
    }
  (*pat_return) = &rfc2132opt_pat;
  return (0);
}

PAT_GET_FIELD_DECL(rfc2132opt_pat_get_field)
{
  t_field			*fields;
  t_field			*fieldptr;
  t_status			status;

  if ((fields = rfc2132opt_get_fields(buf,
				      len,
				      &status)) == NULL)
    return (status);
  fieldptr = NULL;
  while (fields->name)
    {
      if (!strcmp(fields->name,field))
	fieldptr = fields;
      fields++;
    }
  if (!fieldptr)
    return (-ERR_PAT_NO_SUCH_FIELD);
  return (get_field_to_str(buf,
			   len,
			   fieldptr,
			   str,
			   max_len));
}

PAT_SET_FIELD_DECL(rfc2132opt_pat_set_field)
{
  t_field			*fields;
  t_field			*fieldptr;
  t_status			status;
  
  if ((fields = rfc2132opt_get_fields(buf,
				      len,
				      &status)) == NULL)
    return (status);
  fieldptr = NULL;
  while (fields->name)
    {
      if (!strcmp(fields->name,field))
	fieldptr = fields;
      fields++;
    }
  if (!fieldptr)
    return (-ERR_PAT_NO_SUCH_FIELD);
  return (set_field_from_str(buf,
			     len,
			     fieldptr,
			     value));
}

PAT_GET_FIELD_PAT_DECL(rfc2132opt_pat_get_field_pat)
{
  t_field			*fields;	
  t_status			status;

  if ((fields = rfc2132opt_get_fields(buf,
				      len,
				      &status)) == NULL)
    return (status);
  while (fields->name)
    {
      if (!strcmp(field,fields->name))
	{
	  (*pat_return) = fields->pat;
	  (*data_return) = fields->data;
	  return (0);
	}
      fields++;
    }
  return (-ERR_PAT_NO_SUCH_FIELD);
}

PAT_GET_TMPL_DECL(rfc2132opt_pat_get_tmpl)
{
  char		*itmpl;
  t_hash_elt	*he;
  int		i;
  t_status	status;  

  if ((itmpl = rfc2132opt_get_itmpl(buf,
				    len,
				    &status)) == NULL)
    return (status);
  if (he = id_get(id,
		  (VOID_PTR)&rfc2132opt_chan))
    i = (int)(he->value);
  else
    i = 0;
  if ((status = itmpl_format(i,
			     itmpl,
			     str,
			     max_len)) < 0)
    return (status);
  if ((status = id_override(id,
			    (VOID_PTR)&rfc2132opt_chan,
			    (VOID_PTR)(++i))) < 0)
    return (status);
  return (0);
}

PAT_HAS_OPT_DECL(rfc2132opt_pat_has_opt)
{
  t_assoc		*assoc;
  int			tag;
  int			i;

  if (len < 1)
    return (-ERR_PAT_TRUNC);
  tag = (t_u8)(buf[0]);
  if (tag == RFC2132OPT_PAD || tag == RFC2132OPT_END)
    {
      (*has_opt_return) = FALSE;
      return (0);
    }
  if (len < 2)
    return (-ERR_PAT_TRUNC);
  assoc = rfc2132opt_sub_assocs;
  while (i < ARRAY_COUNT(rfc2132opt_sub_assocs))
    {
      if (tag == (int)(assoc->left))
	{
	  (*has_opt_return) = TRUE;
	  (*opt_off_return) = 2;
	  (*opt_len_return) = (t_u8)(buf[1]) - 2;
	  (*opt_pat_return) = (t_pat *)(assoc->right);
	  return (0);
	}
      i++;
    }
  (*has_opt_return) = FALSE;
  return (0);
}
    
t_pat				rfc2132opt_pat = 
{
  rfc2132opt_pat_name,		/* t_pat_name_proc		*/
  rfc2132opt_pat_off,		/* t_pat_off_proc		*/
  rfc2132opt_pat_sub,		/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  rfc2132opt_pat_get_field,	/* t_pat_get_field_proc		*/
  rfc2132opt_pat_set_field,	/* t_pat_set_field_proc		*/
  NULL,				/* t_pat_get_fields_proc	*/
  rfc2132opt_pat_get_tmpl,	/* t_pat_get_tmpl_proc		*/
  NULL,				/* t_pat_get_tmpl2_proc		*/
  rfc2132opt_pat_has_opt,	/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc		*/
  rfc2132opt_pat_get_field_pat,	/* t_pat_get_field_pat_proc	*/
  NULL,				/* t_pat_extract_proc		*/
  NULL,				/* t_pat_insert_proc		*/
  NULL,				/* t_pat_get_choices_proc	*/
};


t_assoc			bootp_op_assocs[] = 
{
  {"request",		(VOID_PTR)1},
  {"reply",		(VOID_PTR)2},
  NULL_ASSOC
};

t_assoc			bootp_htype_assocs[] =
{
  {"ether",		(VOID_PTR)1},
  NULL_ASSOC
};

t_field				bootp_fields[] = 
{
  {"op",	OFFSET(t_bootp *,op),		&u8_pat,		NULL},
  {"Op",	OFFSET(t_bootp *,op),		&u8assoc_pat,bootp_op_assocs},
  {"htype",	OFFSET(t_bootp *,htype),	&u8_pat,		NULL},
  {"Htype",	OFFSET(t_bootp *,htype),      &u8assoc_pat,bootp_htype_assocs},
  {"hlen",	OFFSET(t_bootp *,hlen),	        &u8_pat,		NULL},
  {"hops",	OFFSET(t_bootp *,hops),		&u8_pat,		NULL},
  {"xid",	OFFSET(t_bootp *,xid),		&u32_pat,		NULL},
  {"secs",	OFFSET(t_bootp *,secs),		&u16_pat,		NULL},
  {"unused",	OFFSET(t_bootp *,unused),	&u16_pat,		NULL},
  {"caddr",	OFFSET(t_bootp *,caddr),	&inaddr_pat,		NULL},
  {"Caddr",	OFFSET(t_bootp *,caddr),	&inaddr_resolved_pat,	NULL},
  {"yaddr",	OFFSET(t_bootp *,yaddr),	&inaddr_pat,		NULL},
  {"Yaddr",	OFFSET(t_bootp *,yaddr),	&inaddr_resolved_pat,	NULL},
  {"saddr",	OFFSET(t_bootp *,saddr),	&inaddr_pat,		NULL},
  {"Saddr",	OFFSET(t_bootp *,saddr),	&inaddr_resolved_pat,	NULL},
  {"gaddr",	OFFSET(t_bootp *,gaddr),	&inaddr_pat,		NULL},
  {"Gaddr",	OFFSET(t_bootp *,gaddr),	&inaddr_resolved_pat,	NULL},
  {"chaddr",	OFFSET(t_bootp *,chaddr),	&buf_pat,	(VOID_PTR)16},
  {"sname",	OFFSET(t_bootp *,sname),	&buf_pat,	(VOID_PTR)64},
  {"Sname",	OFFSET(t_bootp *,sname),	&sz_pat,	        NULL},
  {"file",	OFFSET(t_bootp *,file),		&buf_pat,      (VOID_PTR)128},
  {"File",	OFFSET(t_bootp *,file),		&sz_pat,	        NULL},
  {"vendor",	OFFSET(t_bootp *,vendor),	&buf_pat,	(VOID_PTR)64},
  NULL_FIELD
};

char				*bootp_itmpl = "\n\
<table _name=bootp[%i%] width=100%%%% bgcolor=\"%%bootpColor%%\">\n\
<tr>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(bootp[%i%].Op)\">%%bootp[%i%].Op%%</a>\n\
(<a href=\"set(bootp[%i%].op)\">%%bootp[%i%].op%%</a>)\n\
</td>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(bootp[%i%].Htype)\">%%bootp[%i%].Htype%%</a>\n\
(<a href=\"set(bootp[%i%].htype)\">%%bootp[%i%].htype%%</a>)\n\
</td>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(bootp[%i%].hlen)\">%%bootp[%i%].hlen%%</a>\n\
</td>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(bootp[%i%].hops)\">%%bootp[%i%].hops%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].xid)\">%%bootp[%i%].xid%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=50%%%%>\n\
<a href=\"set(bootp[%i%].secs)\">%%bootp[%i%].secs%%</a>\n\
</td>\n\
<td align=center width=50%%%%>\n\
<a href=\"set(bootp[%i%].unused)\">%%bootp[%i%].unused%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Caddr)\">%%bootp[%i%].Caddr%%</a>\n\
(<a href=\"set(bootp[%i%].caddr)\">%%bootp[%i%].caddr%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Yaddr)\">%%bootp[%i%].Yaddr%%</a>\n\
(<a href=\"set(bootp[%i%].yaddr)\">%%bootp[%i%].yaddr%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Saddr)\">%%bootp[%i%].Saddr%%</a>\n\
(<a href=\"set(bootp[%i%].saddr)\">%%bootp[%i%].saddr%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Gaddr)\">%%bootp[%i%].Gaddr%%</a>\n\
(<a href=\"set(bootp[%i%].gaddr)\">%%bootp[%i%].gaddr%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].chaddr)\">%%bootp[%i%].chaddr%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Sname)\">%%bootp[%i%].Sname%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].File)\">%%bootp[%i%].File%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].vendor)\">%%bootp[%i%].vendor%%</a>\n\
</td>\n\
</tr>\n\
</table>\n\
<br>\n\
";

char				*bootp_rfc2132_itmpl = "\n\
<table _name=bootp[%i%] width=100%%%% bgcolor=\"%%bootpColor%%\">\n\
<tr>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(bootp[%i%].Op)\">%%bootp[%i%].Op%%</a>\n\
(<a href=\"set(bootp[%i%].op)\">%%bootp[%i%].op%%</a>)\n\
</td>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(bootp[%i%].Htype)\">%%bootp[%i%].Htype%%</a>\n\
(<a href=\"set(bootp[%i%].htype)\">%%bootp[%i%].htype%%</a>)\n\
</td>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(bootp[%i%].hlen)\">%%bootp[%i%].hlen%%</a>\n\
</td>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(bootp[%i%].hops)\">%%bootp[%i%].hops%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].xid)\">%%bootp[%i%].xid%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=50%%%%>\n\
<a href=\"set(bootp[%i%].secs)\">%%bootp[%i%].secs%%</a>\n\
</td>\n\
<td align=center width=50%%%%>\n\
<a href=\"set(bootp[%i%].unused)\">%%bootp[%i%].unused%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Caddr)\">%%bootp[%i%].Caddr%%</a>\n\
(<a href=\"set(bootp[%i%].caddr)\">%%bootp[%i%].caddr%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Yaddr)\">%%bootp[%i%].Yaddr%%</a>\n\
(<a href=\"set(bootp[%i%].yaddr)\">%%bootp[%i%].yaddr%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Saddr)\">%%bootp[%i%].Saddr%%</a>\n\
(<a href=\"set(bootp[%i%].saddr)\">%%bootp[%i%].saddr%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Gaddr)\">%%bootp[%i%].Gaddr%%</a>\n\
(<a href=\"set(bootp[%i%].gaddr)\">%%bootp[%i%].gaddr%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].chaddr)\">%%bootp[%i%].chaddr%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].Sname)\">%%bootp[%i%].Sname%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(bootp[%i%].File)\">%%bootp[%i%].File%%</a>\n\
</td>\n\
</tr>\n\
</table>\n\
<br>\n\
";

int	bootp_chan;

PAT_NAME_GENERIC(bootp_pat_name,
		 (VOID_PTR)&bootp_chan,
		 "bootp")

PAT_GET_FIELD_GENERIC(bootp_pat_get_field,
		      bootp_fields)

PAT_SET_FIELD_GENERIC(bootp_pat_set_field,
		      bootp_fields)

PAT_GET_FIELDS_GENERIC(bootp_pat_get_fields,
		       bootp_fields)

PAT_GET_FIELD_PAT_GENERIC(bootp_pat_get_field_pat,
			  bootp_fields)

PAT_GET_TMPL_DECL(bootp_pat_get_tmpl)
{
  if (pat_bootp_rfc2132)
    return (pat_get_itmpl_generic(id,
				  buf,
				  len,
				  str,
				  max_len,
				  (VOID_PTR)&bootp_chan,
				  bootp_rfc2132_itmpl));
  else
    return (pat_get_itmpl_generic(id,
				  buf,
				  len,
				  str,
				  max_len,
				  (VOID_PTR)&bootp_chan,
				  bootp_itmpl));
}
 
PAT_OFF_GENERIC(bootp_pat_off,
		BOOTP_HLEN)

PAT_SUB_GENERIC(bootp_pat_sub,
		&data_pat)
    
PAT_HAS_OPT_DECL(bootp_pat_has_opt)
{
  t_bootp		*bootp;

  PAT_BOOTP_CHECK(bootp,buf,len);
  if (pat_bootp_rfc2132)
    {
      (*has_opt_return) = TRUE;
      (*opt_off_return) = OFFSET(t_bootp *,vendor);
      (*opt_len_return) = 64;
      (*opt_pat_return) = &rfc2132opt_pat;
    }
  else
    {
      (*has_opt_return) = FALSE;
    }
  return (0);
}

t_pat				bootp_pat = 
{
  bootp_pat_name,		/* t_pat_name_proc		*/
  bootp_pat_off,		/* t_pat_off_proc		*/
  bootp_pat_sub,		/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  bootp_pat_get_field,		/* t_pat_get_field_proc		*/
  bootp_pat_set_field,		/* t_pat_set_field_proc		*/
  bootp_pat_get_fields,		/* t_pat_get_fields_proc	*/
  bootp_pat_get_tmpl,		/* t_pat_get_tmpl_proc		*/
  NULL,				/* t_pat_get_tmpl2_proc		*/
  bootp_pat_has_opt,		/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc		*/
  bootp_pat_get_field_pat,	/* t_pat_get_field_pat_proc	*/
  NULL,				/* t_pat_extract_proc		*/
  NULL,				/* t_pat_insert_proc		*/
  NULL,				/* t_pat_get_choices_proc	*/
};
