/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include "pat.h"
#include "pat_data.h"
#include "pat_buf.h"

int	buf_chan;

PAT_NAME_GENERIC(buf_pat_name,
		 (VOID_PTR)&buf_chan,
		 "buf")

PAT_EXTRACT_DECL(buf_pat_extract)
{
  int		ulen;
  
  if ((ulen = (int)(data)) == 0)
    return (-ERR_PAT_NULL_DATA);
  if (len < ulen)
    return (-ERR_PAT_TRUNC);
  return (buf_to_xdata_str(buf,
			   ulen,
			   pat_data_bytes_per_line,
			   "\n",
			   " ",
			   str,
			   max_len));
}

PAT_INSERT_DECL(buf_pat_insert)
{
  t_status	status;	
  int		ilen;
  char		my_buf[BUFSIZ];
    
  if ((status = xdata_to_buf(value,
			     buf,
			     &ilen,
			     sizeof (my_buf))) < 0)
    return (status);
  if (len < ilen)
    return (-ERR_PAT_TRUNC);
  bcopy(my_buf,buf,ilen);
  return (0);
}

PAT_OFF_DECL(buf_pat_off)
{
  (*off_return) = (t_off)(data);
  return (0);
}	

t_pat				buf_pat = 
{
  buf_pat_name,			/* t_pat_name_proc		*/
  buf_pat_off,			/* t_pat_off_proc		*/
  NULL,				/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  NULL,				/* t_pat_get_field_proc		*/
  NULL,				/* t_pat_set_field_proc		*/
  NULL,				/* t_pat_get_fields_proc	*/
  NULL,				/* t_pat_get_tmpl_proc		*/
  NULL,				/* t_pat_get_tmpl2_proc		*/
  NULL,				/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc		*/
  NULL,				/* t_pat_get_field_pat_proc	*/
  buf_pat_extract,		/* t_pat_extract_proc		*/
  buf_pat_insert,		/* t_pat_insert_proc		*/
  NULL,				/* t_pat_get_choices_proc	*/
};
