/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "pat_rip.h"
#include "pat_ip.h"
#include "pat_ether.h"
#include "pat_tracert.h"
#include "pat_data.h"
#include "pat_32.h"
#include "pat_16.h"
#include "pat_8.h"
#include "pat_time.h"

t_field				tracert_fields[] = 
{
  {"seq",	OFFSET(t_tracert *,seq),	&u8_pat,	NULL},
  {"ttl",	OFFSET(t_tracert *,ttl),	&u8_pat,	NULL},
  {"tvsec",	OFFSET(t_tracert *,tv.tv_sec),	&nu32_pat,	NULL},
  {"Tvsec",	OFFSET(t_tracert *,tv.tv_sec),	&time_pat,	NULL},
  {"tvusec",	OFFSET(t_tracert *,tv.tv_usec),	&nu32_pat,	NULL},
  {"Tvusec",	OFFSET(t_tracert *,tv.tv_usec),	&time_pat,	NULL},
  NULL_FIELD
};

char				*tracert_itmpl = "\n\
<table _name=tracert[%i%] width=100%%%% bgcolor=\"%%tracertColor%%\">\n\
<tr>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(tracert[%i%].seq)\">%%tracert[%i%].seq%%</a>\n\
</td>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(tracert[%i%].ttl)\">%%tracert[%i%].ttl%%</a>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(tracert[%i%].Tvsec)\">%%tracert[%i%].Tvsec%%</a>\n\
(<a href=\"set(tracert[%i%].tvsec)\">%%tracert[%i%].tvsec%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(tracert[%i%].Tvusec)\">%%tracert[%i%].Tvusec%%</a>\n\
(<a href=\"set(tracert[%i%].tvusec)\">%%tracert[%i%].tvusec%%</a>)\n\
</td>\n\
</tr>\n\
</table>\n\
<br>\n\
";

int	tracert_chan;

PAT_NAME_GENERIC(tracert_pat_name,
		 (VOID_PTR)&tracert_chan,
		 "tracert")

PAT_GET_FIELD_GENERIC(tracert_pat_get_field,
		      tracert_fields)

PAT_SET_FIELD_GENERIC(tracert_pat_set_field,
		      tracert_fields)

PAT_GET_FIELDS_GENERIC(tracert_pat_get_fields,
		       tracert_fields)

PAT_GET_FIELD_PAT_GENERIC(tracert_pat_get_field_pat,
			  tracert_fields)

PAT_GET_TMPL_GENERIC(tracert_pat_get_tmpl,
		     (VOID_PTR)&tracert_chan,
		     tracert_itmpl)

PAT_OFF_GENERIC(tracert_pat_off,
		TRACERT_HLEN)

PAT_SUB_GENERIC(tracert_pat_sub,
		&data_pat)

t_pat				tracert_pat = 
{
  tracert_pat_name,		/* t_pat_name_proc		*/
  tracert_pat_off,		/* t_pat_off_proc		*/
  tracert_pat_sub,		/* t_pat_sub_proc		*/
  NULL,				/* t_pat_sum_proc		*/
  tracert_pat_get_field,	/* t_pat_get_field_proc		*/
  tracert_pat_set_field,	/* t_pat_set_field_proc		*/
  tracert_pat_get_fields,	/* t_pat_get_fields_proc	*/
  tracert_pat_get_tmpl,		/* t_pat_get_tmpl_proc		*/
  NULL,				/* t_pat_get_tmpl2_proc		*/
  NULL,				/* t_pat_has_opt_proc		*/
  NULL,				/* t_pat_adapt_len_proc		*/
  tracert_pat_get_field_pat,	/* t_pat_get_field_pat_proc	*/
  NULL,				/* t_pat_extract_proc		*/
  NULL,				/* t_pat_insert_proc		*/
  NULL,				/* t_pat_get_choices_proc	*/
};
