/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include "paterr.h"

char		*err_pat_list[] = 
{
  "Error 0",					/* 0 */
  "Bad address",
  "Bad format",
  "Bad header",
  "Bad length",
  "Bad match",					/* 5 */
  "Bad string-zero",
  "Bad ASCII vector",
  "Can't handle",
  "Channel is in use",
  "Netmask contains holes",			/* 10 */
  "Invalid argument",
  "Malformed",	
  "Need more arguments",
  "Not implemented",
  "No choice",					/* 15 */
  "No entry",	
  "Open error",	
  "Read error",	
  "Too big",					
  "Truncated",					/* 20 */
  "Unresolvable",
  "Zero length or exact match",
  "No such field",	
  "Write error",
  "Syscall error",				/* 25 */	
  "Loop, e.g zero length offset",
  "Not enough room",			
  "Bad family",				
  "No method name",
  "No method off",				/* 30 */
  "No method sub",
  "No method sum",
  "No method get field",
  "No method set field",
  "No method get fields",			/* 35 */
  "No method get tmpl",
  "No method has opt",
  "No method adapt len",
  "No method get field pat",
  "No method extract",				/* 40 */
  "No method insert",
  "No method get choices",
  "Exact match",
  "Null data",
  "Option doesn't match",			/* 45 */
  "Protocol error in pktio stuff",
};

t_status	err_pat_init(VOID_DECL)
{
  t_status	status;
  int		i;

  assert(err_id);
  i = 0;
  while (i < ARRAY_COUNT(err_pat_list))
    {
      if ((status = id_add(err_id,
			   (VOID_PTR)(ERR_PAT_START + i),
			   err_pat_list[i])) < 0)
	return (status);
      i++;
    }
  return (0);
}	
