/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef XIPCF_H
#define XIPCF_H	1

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include "XmgFancy.h"
#include "a.h"
#include "pat_ether.h"
#include "pat_ip.h"
#include "pat_inaddr.h"
#include "pat_ethaddr.h"
#include "pat_8.h"
#include "pat_16.h"
#include "pat_32.h"
#include "pat_subnet.h"

typedef struct			s_xip_var
{
  char				*name;			/* must be static */
  t_off				offset;
  size_t			size;	
  t_pat				*pat;
  VOID_PTR			data;
} t_xip_var;

#define NULL_XIP_VAR		{NULL,0,0,NULL,NULL}

extern char			*tmpl_buf;
extern char			*html_buf;
extern char			*htmlize_buf;
extern t_u32			tmpl_bufsiz;
extern t_u32			html_bufsiz;
extern t_u32			htmlize_bufsiz;
extern struct in_addr		ghost_ip;
extern t_ether_addr		ghost_ether;
extern t_u16			ip_id;

typedef struct			s_xip_cf_box_entry
{
  char				*widget_name;
  char				*var;
} t_xip_cf_box_entry;

#define NULL_XIP_CF_BOX_ENTRY	{NULL,NULL}

typedef struct			s_xip_cf_box_group
{
  char				*widget_name;	/* must be static */
  char				*label;		/* must be static */
  t_xip_cf_box_entry		*entries;	/* must be static */
} t_xip_cf_box_group;

#define NULL_XIP_CF_BOX_GROUP	{NULL,NULL,NULL}

typedef t_status		(*t_xip_plugin_proc) P((VOID_DECL));

/* PROTO xipcf.c */
/* xipcf.c */
#endif
