/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include "xiperr.h"

char		*err_xip_list[] = 
{
  "Error 0",					/* 0 */
  "Can't reply",				/* 1 */
  "Internal error",				/* 2 */
  "Packet is in use",				/* 3 */
  "Syntax error",				/* 4 */
  "Error occured in a subroutine",		/* 5 */
  "Syscall error",				/* 6 */
  "No method",					/* 7 */
  "Open error",					/* 8 */
  "Missing variable",				/* 9 */
  "Can't handle",				/* 10 */
  "No such variable",				/* 11 */
  "No entry",					/* 12 */
  "Write error",				/* 13 */
  "Read error",					/* 14 */
  "Bad X event",				/* 15 */
  "Not implemented",				/* 16 */
  "Error occured in a child process",		/* 17 */
  "Need at least one argument",			/* 18 */
  "Bad message length",				/* 19 */
  "Too many arguments",				/* 20 */
};

t_status	err_xip_init(VOID_DECL)
{
  t_status	status;
  int		i;

  assert(err_id);
  i = 0;
  while (i < ARRAY_COUNT(err_xip_list))
    {
      if ((status = id_add(err_id,
			   (VOID_PTR)(ERR_XIP_START + i),
			   err_xip_list[i])) < 0)
	return (status);
      i++;
    }
  return (0);
}	
